unit UMetPuntuales;

interface

uses
  Winapi.Windows, math,
  UMetBase ;

  procedure FP_Negativo(matriz : matImg; var matrizSal: matImg);
  procedure FP_Parabola(matriz : matImg; var matrizSal: matImg);
  procedure FP_RaizCuad(matriz : matImg; var matrizSal: matImg);
  procedure FP_Log     (matriz : matImg; var matrizSal: matImg);

implementation

// Negativo
procedure FP_Negativo(matriz : matImg; var matrizSal : matImg);
var
 kx,ky,cc   : integer;
begin
  for cc := 0 to 2 do if _Kanal[cc] then
    for ky := 0 to matriz.nr-1 do
      for kx := 0 to matriz.nc-1 do
         matrizSal.dat[kx][ky][cc] := _lamb - matriz.dat[kx][ky][cc];
end;

// Obscurece usando una parabola : z' = Lamb *(z/Lamb)**2
procedure FP_Parabola(matriz : matImg; var matrizSal: matImg);
var
 kx,ky,cc   : integer;
begin
  for cc := 0 to 2 do if _Kanal[cc] then
    for ky := 0 to matriz.nr-1 do
      for kx := 0 to matriz.nc-1 do
         matrizSal.dat[kx][ky][cc] := _lamb*sqr(matriz.dat[kx][ky][cc]/_lamb);
end;

// Aclara usando raiz cuadrada : z' = Lamb *(z/Lamb)**0.5
procedure FP_RaizCuad(matriz : matImg; var matrizSal: matImg);
var
 kx,ky,cc   : integer;
begin
  for cc := 0 to 2 do if _Kanal[cc] then
    for ky := 0 to matriz.nr-1 do
      for kx := 0 to matriz.nc-1 do
         matrizSal.dat[kx][ky][cc] := _lamb*sqrt(matriz.dat[kx][ky][cc]/_lamb);
end;

// Logartmico o rango dinmico
procedure FP_Log     (matriz : matImg; var matrizSal: matImg);
var
 kx,ky,cc   : integer;
 ff         : single;
begin
  ff := _lamb/ln(_lamb+1);

  // cuidar entradas negativas en la matriz

  for cc := 0 to 2 do if _Kanal[cc] then
    for ky := 0 to matriz.nr-1 do
      for kx := 0 to matriz.nc-1 do
         matrizSal.dat[kx][ky][cc] := ff*ln(matriz.dat[kx][ky][cc]+1);
end;

end.
