unit Unit1;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils,
  System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.ExtCtrls,
  Vcl.StdCtrls, Vcl.ExtDlgs, Vcl.ComCtrls,

  JPEG,PNGImage,GIFImg, Vcl.Menus,

  UMetBase, UMetPuntuales, Vcl.ToolWin, Vcl.ImgList,
  UHisto,

  Demo03_MainForm;

type
  TForm1 = class(TForm)
    ScrollBox1: TScrollBox;
    Image1: TImage;
    OpenPictureDialog1: TOpenPictureDialog;
    StatusBar1: TStatusBar;
    StatusBar2: TStatusBar;

    MainMenu1: TMainMenu;
      Archivo1: TMenuItem;
        Abrir1: TMenuItem;
      Varios1: TMenuItem;
      OpPuntuales1: TMenuItem;
        Negativo1: TMenuItem;
    Negativo2: TMenuItem;
    N1: TMenuItem;
    ObscureceParabola1: TMenuItem;
    AclaraRaizCuadrada1: TMenuItem;
    StatusBar3: TStatusBar;
    Salvar1: TMenuItem;
    N2: TMenuItem;
    Salida1: TMenuItem;
    SavePictureDialog1: TSavePictureDialog;
    Panel1: TPanel;
    CheckBox1: TCheckBox;
    CheckBox2: TCheckBox;
    CheckBox3: TCheckBox;
    Logaritmo1: TMenuItem;
    ToolBar1: TToolBar;
    ToolButton1: TToolButton;
    ToolButton2: TToolButton;
    ToolButton3: TToolButton;
    ToolButton4: TToolButton;
    ToolButton5: TToolButton;
    ToolButton6: TToolButton;
    ToolButton7: TToolButton;
    ToolButton8: TToolButton;
    ImageList1: TImageList;
    Histograma1: TMenuItem;
    ToolButton9: TToolButton;
    CapturaWebCam1: TMenuItem;

    procedure Image1MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure FormCreate(Sender: TObject);
    procedure Abrir1Click(Sender: TObject);
    procedure Negativo1Click(Sender: TObject);
    procedure Negativo2Click(Sender: TObject);
    procedure ObscureceParabola1Click(Sender: TObject);
    procedure AclaraRaizCuadrada1Click(Sender: TObject);
    procedure Salvar1Click(Sender: TObject);
    procedure CheckBox1Click(Sender: TObject);
    procedure Logaritmo1Click(Sender: TObject);
    procedure Histograma1Click(Sender: TObject);
    procedure CapturaWebCam1Click(Sender: TObject);

  private
    { Private declarations }
  public
    { Public declarations }
    nom : string;

    BMT     : TBitMap;
    Im1,Im2 : matImg;

    procedure preparaProceso();
    procedure muestraImagen();
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}


// Mtodos Internos

procedure TForm1.preparaProceso();
begin
  if (Im2.nc+Im2.nr) = 0
    then DefMatriz(Im2, Im1.nc, Im1.nr)
    else copiaMat(Im2,Im1);
end;

procedure TForm1.muestraImagen();
begin
  Mat2BitMap(Im2,BMT);
  Image1.Picture.Assign(BMT);
end;

// ----------- Mtodos de Interface -----------------

// Create
procedure TForm1.FormCreate(Sender: TObject);
begin
  BMT := TBitMap.Create;
  StatusBar3.Panels[1].Text := 'Ninguno An';
  icon.LoadFromFile('5.ico');
end;

// Abrir Imagen
procedure TForm1.Abrir1Click(Sender: TObject);
var
  PIC  : TPicture;
begin
  if OpenPictureDialog1.Execute then begin
    nom := OpenPictureDialog1.FileName;

    PIC := TPicture.Create;
    try
      PIC.LoadFromFile(nom );

      BMT.Width  := PIC.Width;
      BMT.Height := PIC.Height;
      BMT.Canvas.Draw(0,0,PIC.Graphic);
      Image1.Picture.Assign(BMT);

      BitMap2Mat(BMT,Im1);

      _x1 := 0      ;  _y1 := 0;
      _x2 := Im1.nc ;  _y2 := Im1.nr;


      DefMatriz(Im2,0,0);

      StatusBar1.Panels[5].Text := IntToStr(BMT.Width );
      StatusBar1.Panels[6].Text := IntToStr(BMT.Height );

      StatusBar3.Panels[1].Text := nom;
    finally
      PIC.Free;
    end;
  end;
end;

// Capturar de WebCam
procedure TForm1.CapturaWebCam1Click(Sender: TObject);
begin
  FormWCam.ShowModal;

  if (FormWCam.ModalResult = mrOK) then begin

    BMT.Assign(FormWCam.fVideoBitmap);

    Image1.Picture.Assign(BMT);

    BitMap2Mat(BMT,Im1);

    _x1 := 0      ;  _y1 := 0;
    _x2 := Im1.nc ;  _y2 := Im1.nr;


    DefMatriz(Im2,0,0);

    StatusBar1.Panels[5].Text := IntToStr(BMT.Width );
    StatusBar1.Panels[6].Text := IntToStr(BMT.Height );

    nom := 'webimage.bmp';
    StatusBar3.Panels[1].Text := nom;
  end;

end;

// Salvar Imagen
procedure TForm1.Salvar1Click(Sender: TObject);
begin
  if SavePictureDialog1.Execute then begin
    nom := SavePictureDialog1.FileName;

    SalvaImagen(BMT, nom);
    StatusBar3.Panels[1].Text := nom;
  end;
end;


procedure TForm1.Histograma1Click(Sender: TObject);
begin
  FormHisto.Show;
end;

// Mouse Move
procedure TForm1.Image1MouseMove(Sender: TObject;
  Shift: TShiftState;
  X, Y: Integer);

var
 r,g,b : byte;
 pix   : TColor;

begin
  StatusBar1.Panels[0].Text := IntToStr(X);
  StatusBar1.Panels[1].Text := IntToStr(Y);

  pix := BMT.Canvas.Pixels[X,Y];
  r := GetRValue(pix);
  g := GetGValue(pix);
  b := GetBValue(pix);

  StatusBar1.Panels[2].Text := IntToStr(r);
  StatusBar1.Panels[3].Text := IntToStr(g);
  StatusBar1.Panels[4].Text := IntToStr(b);
end;

procedure TForm1.CheckBox1Click(Sender: TObject);
var
  status : string;

  procedure estado (kk : byte; bb : boolean);
  begin
    if bb
      then status[kk+1] := '1'
      else status[kk+1] := '0'
  end;

begin
  status := StatusBar1.Panels[7].Text;

  if (Sender as TCheckBox).Name = 'CheckBox1' then begin
    _Kanal[0] := CheckBox1.Checked;
    estado(0,_Kanal[0]);
  end;

  if (Sender as TCheckBox).Name = 'CheckBox2' then begin
    _Kanal[1] := CheckBox2.Checked;
    estado(1,_Kanal[1]);
  end;

  if (Sender as TCheckBox).Name = 'CheckBox3' then begin
    _Kanal[2] := CheckBox3.Checked;
    estado(2,_Kanal[2]);
  end;

  StatusBar1.Panels[7].Text := status;
end;


//  --------------  Filtros Puntuales -------------------

// Negativo sobre el BitMap
procedure TForm1.Negativo1Click(Sender: TObject);
var
 r,g,b : byte;
 pix   : TColor;
 kx,ky,
 nx,ny : integer;
begin
   nx := BMT.Width;
   ny := BMT.Height;

   // operacion del negativo
   for kx := 0 to nx-1 do
     for ky := 0 to ny-1 do begin
       pix := BMT.Canvas.Pixels[kx,ky];

       r := _lamb - GetRValue(pix);
       g := _lamb - GetGValue(pix);
       b := _lamb - GetBValue(pix);

       pix := RGB(r,g,b);
       BMT.Canvas.Pixels[kx,ky] := pix;
     end;

   // mandar a la interfase
   Image1.Picture.Assign(BMT);
end;

// Negativo sobre la Matriz
procedure TForm1.Negativo2Click(Sender: TObject);
begin
  preparaProceso();

  FP_Negativo(Im1,Im2);

  muestraImagen();
end;

procedure TForm1.ObscureceParabola1Click(Sender: TObject);
begin
  preparaProceso();

  FP_Parabola (Im1,Im2);

  muestraImagen();
end;

// Aclara con raiz cuadrada
procedure TForm1.AclaraRaizCuadrada1Click(Sender: TObject);
begin
  preparaProceso();

  FP_RaizCuad (Im1,Im2);

  muestraImagen();
end;

// Logaritmo o Rango Dinmico
procedure TForm1.Logaritmo1Click(Sender: TObject);
begin
  preparaProceso();

  FP_Log (Im1,Im2);

  muestraImagen();
end;

end.
